## matrix-synapse 1.78.0

=== pyo3/emscripten/Makefile ===
CURDIR=$(abspath .)

# These three are passed in from nox.
BUILDROOT ?= $(CURDIR)/builddir
PYMAJORMINORMICRO ?= 3.11.0
PYPRERELEASE ?= b4 # I'm not sure how to split 3.11.0b4 in Make.

EMSCRIPTEN_VERSION=3.1.13

export EMSDKDIR = $(BUILDROOT)/emsdk

PLATFORM=wasm32_emscripten
SYSCONFIGDATA_NAME=_sysconfigdata__$(PLATFORM)

# BASH_ENV tells bash to source emsdk_env.sh on startup.
export BASH_ENV := $(CURDIR)/env.sh
# Use bash to run each command so that env.sh will be used.
SHELL := /bin/bash


# Set version variables.
version_tuple := $(subst ., ,$(PYMAJORMINORMICRO:v%=%))
PYMAJOR=$(word 1,$(version_tuple))
PYMINOR=$(word 2,$(version_tuple))
PYMICRO=$(word 3,$(version_tuple))
PYVERSION=$(PYMAJORMINORMICRO)$(PYPRERELEASE)
PYMAJORMINOR=$(PYMAJOR).$(PYMINOR)


PYTHONURL=https://www.python.org/ftp/python/$(PYMAJORMINORMICRO)/Python-$(PYVERSION).tgz
PYTHONTARBALL=$(BUILDROOT)/downloads/Python-$(PYVERSION).tgz
PYTHONBUILD=$(BUILDROOT)/build/Python-$(PYVERSION)

PYTHONLIBDIR=$(BUILDROOT)/install/Python-$(PYVERSION)/lib

all: $(PYTHONLIBDIR)/libpython$(PYMAJORMINOR).a

$(BUILDROOT)/.exists: 
	mkdir -p $(BUILDROOT)
	touch $@


# Install emscripten
$(EMSDKDIR): $(CURDIR)/emscripten_patches/* $(BUILDROOT)/.exists
	git clone https://github.com/emscripten-core/emsdk.git --depth 1 --branch $(EMSCRIPTEN_VERSION) $(EMSDKDIR)
	$(EMSDKDIR)/emsdk install $(EMSCRIPTEN_VERSION)
	cd $(EMSDKDIR)/upstream/emscripten && cat $(CURDIR)/emscripten_patches/* | patch -p1
	$(EMSDKDIR)/emsdk activate $(EMSCRIPTEN_VERSION)


$(PYTHONTARBALL):
	[ -d $(BUILDROOT)/downloads ] || mkdir -p $(BUILDROOT)/downloads
	wget -q -O $@ $(PYTHONURL)

$(PYTHONBUILD)/.patched: $(PYTHONTARBALL)
	[ -d $(PYTHONBUILD) ] || ( \
		mkdir -p $(dir $(PYTHONBUILD));\
		tar -C $(dir $(PYTHONBUILD)) -xf $(PYTHONTARBALL) \
	)
	touch $@

$(PYTHONBUILD)/Makefile: $(PYTHONBUILD)/.patched $(BUILDROOT)/emsdk
	cd $(PYTHONBUILD) && \
	CONFIG_SITE=Tools/wasm/config.site-wasm32-emscripten \
  	emconfigure ./configure -C \
		--host=wasm32-unknown-emscripten \
		--build=$(shell $(PYTHONBUILD)/config.guess) \
		--with-emscripten-target=browser \
		--enable-wasm-dynamic-linking \
		--with-build-python=python3.11

$(PYTHONLIBDIR)/libpython$(PYMAJORMINOR).a : $(PYTHONBUILD)/Makefile
	cd $(PYTHONBUILD) && \
		emmake make -j3 libpython$(PYMAJORMINOR).a

	# Generate sysconfigdata
	_PYTHON_SYSCONFIGDATA_NAME=$(SYSCONFIGDATA_NAME) _PYTHON_PROJECT_BASE=$(PYTHONBUILD) python3.11 -m sysconfig --generate-posix-vars
	cp `cat pybuilddir.txt`/$(SYSCONFIGDATA_NAME).py $(PYTHONBUILD)/Lib

	mkdir -p $(PYTHONLIBDIR)
	# Copy libexpat.a, libmpdec.a, and libpython3.11.a
	# In noxfile, we explicitly link libexpat and libmpdec via RUSTFLAGS
	find $(PYTHONBUILD) -name '*.a' -exec cp {} $(PYTHONLIBDIR) \;
	# Install Python stdlib
	cp -r $(PYTHONBUILD)/Lib $(PYTHONLIBDIR)/python$(PYMAJORMINOR)

clean:
	rm -rf $(BUILDROOT)

=== debian/changelog ===
matrix-synapse (1.78.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Adjust dependencies.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 18 Mar 2023 08:01:24 +0100

matrix-synapse (1.78.0-1) unstable; urgency=medium

  * New upstream release.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 01 Mar 2023 22:49:36 +0100

matrix-synapse (1.74.0-1~bpo11+2) bullseye-backports; urgency=medium

  * Relax optional dependency on pyicu to 2.5.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 20 Feb 2023 12:07:57 +0100

matrix-synapse (1.74.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 19 Feb 2023 09:35:24 +0100

matrix-synapse (1.73.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 24 Dec 2022 15:24:05 +0100

matrix-synapse (1.72.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 01 Dec 2022 09:24:24 +0100

matrix-synapse (1.71.0-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 23 Nov 2022 14:26:29 +0100

matrix-synapse (1.70.1-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 04 Nov 2022 10:53:53 +0100

matrix-synapse (1.69.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 26 Oct 2022 18:37:50 +0200

matrix-synapse (1.68.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 18 Oct 2022 10:35:21 +0100

matrix-synapse (1.66.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Update the pip dependency patch to work with Python 3.9.
  * Require Python 3.9.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 06 Sep 2022 21:41:03 +0200

matrix-synapse (1.63.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 09 Aug 2022 15:10:33 +0200

matrix-synapse (1.61.0-1~bpo11+3) bullseye-backports; urgency=medium

  * SECURITY ISSUE: GHSA-22p3-qrh9-cx32 / CVE-2022-31052.
    Synapse instances with the url_preview_enabled homeserver config option
    set to true are affected. URL previews of some web pages can lead to
    unbounded recursion, causing the request to either fail, or in some
    cases crash the running Synapse process.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 28 Jun 2022 19:03:13 +0200

matrix-synapse (1.61.0-1~bpo11+2) bullseye-backports; urgency=medium

  * Patch the matrix-common dependency to >= (Closes: #1013745).

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 25 Jun 2022 12:21:18 +0200

matrix-synapse (1.61.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 24 Jun 2022 09:37:49 +0200

matrix-synapse (1.59.1-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 19 Jun 2022 15:18:18 +0200

matrix-synapse (1.57.1-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 04 May 2022 14:18:44 +0100

matrix-synapse (1.55.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 29 Mar 2022 09:34:18 +0200

matrix-synapse (1.53.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 05 Mar 2022 07:52:56 +0100

matrix-synapse (1.52.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 16 Feb 2022 13:48:38 +0100

matrix-synapse (1.51.0-1~bpo11+2) bullseye-backports; urgency=medium

  * Depend on newer dh-python to ensure proper dependencies of binary
    packages.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 09 Feb 2022 12:02:23 +0100

matrix-synapse (1.51.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 08 Feb 2022 23:23:34 +0100

matrix-synapse (1.49.0-1~bpo11+3) bullseye-backports; urgency=medium

  * Fix an endless loop with "Invalid prev_events for <event_id>".

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 24 Jan 2022 17:41:55 +0100

matrix-synapse (1.49.0-1~bpo11+2) bullseye-backports; urgency=medium

  * Fix a regression by cherry-picking an upstream fix from 1.49.2.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 21 Dec 2021 20:55:17 +0100

matrix-synapse (1.49.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 21 Dec 2021 16:57:15 +0100

matrix-synapse (1.48.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 06 Dec 2021 08:38:44 +0100

matrix-synapse (1.47.1-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 25 Nov 2021 09:13:01 +0100

matrix-synapse (1.47.0-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Fix security vulnerability in the media repository
    (CVE-2021-41281).

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 23 Nov 2021 13:10:15 +0100

matrix-synapse (1.46.0-1~bpo11+3) bullseye-backports; urgency=high

  * Fix security vulnerability in the media repository
    (CVE-2021-41281).

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 23 Nov 2021 00:00:00 +0000

matrix-synapse (1.46.0-1~bpo11+2) bullseye-backports; urgency=medium

  * Rebuild.



=== debian/control ===
Source: matrix-synapse
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders: Andrej Shadura <andrewsh@debian.org>
Section: net
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 dh-python (>= 5),
 libjs-jquery,
 po-debconf,
 pybuild-plugin-pyproject,
 python3-poetry-core,
 python3-all,
 python3-attr (>= 19.2.0~),
 python3-bcrypt,
 python3-bleach (>= 1.4.2),
 python3-cryptography,
 python3-canonicaljson (>= 1.6.2~),
 python3-daemonize,
 python3-frozendict (>= 1.2-3~),
 python3-icu (>= 2.5~),
 python3-idna,
 python3-ijson (>= 3.1.4),
 python3-jinja2 (>= 3.0),
 python3-jsonschema (>= 3.0.0),
 python3-lxml (>= 4.2.0),
 python3-matrix-common (>= 1.3.0~),
 python3-mock,
 python3-msgpack (>= 0.5.0),
 python3-nacl (>= 1.2.1),
 python3-netaddr (>= 0.7.18),
 python3-openssl (>= 0.14),
 python3-packaging (>= 16.1),
 python3-phonenumbers,
 python3-pil (>= 5.4.0),
 python3-prometheus-client,
 python3-psutil,
 python3-pyasn1,
 python3-pydantic (>= 1.7.4),
 python3-pymacaroons (>= 0.13.0),
 python3-pysaml2 (>= 4.0.0),
 python3-service-identity (>= 18.1.0),
 python3-setuptools (>= 0.6b3),
 python3-setuptools-rust (>= 1.2.0~),
 python3-signedjson (>= 1.1.0),
 python3-sortedcontainers,
 python3-systemd,
 python3-treq (>= 18),
 python3-twisted (>= 18.9.0-8~),
 python3-typing-extensions (>= 3.10~),
 python3-unpaddedbase64 (>= 2.1.0~),
 python3-yaml
Standards-Version: 4.6.0
Homepage: https://matrix.org/docs/projects/server/synapse.html
Vcs-Browser: https://salsa.debian.org/matrix-team/matrix-synapse
Vcs-Git: https://salsa.debian.org/matrix-team/matrix-synapse.git
Rules-Requires-Root: no

Package: matrix-synapse
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 adduser,
 libjs-jquery,
 lsb-base (>= 3.0-6),
 libpython3-stdlib (<< 3.6.4~rc1-2~) | python3-distutils,
 python3 (>= 3.9),
 python3-bleach,
 python3-jinja2 (>= 3.0~),
 python3-lxml,
 python3-psycopg2 (>= 2.8),
 python3-systemd,
 python3-twisted (>= 18.9.0-8~),
 ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
 ${perl:Depends}
Breaks:
 matrix-synapse-ldap3 (<< 0.1.3-2~)
Suggests:
 python3-jwt (>= 1.6.4),
 python3-authlib (>= 0.14.0),
Recommends:
 python3-pympler,
 matrix-synapse-ldap3,
#  python3-priority,
#  python3-h2 (>= 3.0.0)
Description: Matrix reference homeserver
 Synapse is the reference Python/Twisted Matrix homeserver implementation.
 .
 Synapse is intended to showcase the concept of Matrix, and to let users run
 their own homeserver and generally help bootstrap the ecosystem.
 .
 Matrix is an open standard for interoperable, decentralised, real-time
 communication over IP. It can be used to power Instant Messaging, VoIP/WebRTC
 signalling, Internet of Things communication or anywhere where's a need for
 a standard HTTP API for publishing and subscribing to data whilst tracking the
 conversation history.
 .
 In Matrix, every user runs one or more Matrix clients, which connect through
 to a Matrix homeserver. The homeserver stores all their personal chat history
 and user account information, much as a mail client connects through to an
 IMAP/SMTP server.

## matrix-synapse 1.90.0

=== debian/changelog ===
matrix-synapse (1.90.0-1) unstable; urgency=medium

  [ Andrej Shadura ]
  * New upstream release.
  * Update licenses.
  * Build Rust extension reproducibly.

  [ Antonio Russo ]
  * Refresh patches.
  * Refresh canonicaljson dependency.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 31 Aug 2023 14:46:27 +0200

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
+ dh-sequence-single-binary,
  dh-sequence-python3,
- dh-python (>= 5),
  libjs-jquery,
  po-debconf,
  pybuild-plugin-pyproject,
@@ -16,10 +16,10 @@
  python3-bcrypt,
  python3-bleach (>= 1.4.2),
  python3-cryptography,
- python3-canonicaljson (>= 1.6.2~),
+ python3-canonicaljson (>= 2.0.0~),
  python3-daemonize,
  python3-frozendict (>= 1.2-3~),
- python3-icu (>= 2.5~),
+ python3-icu (>= 2.10.2~),
  python3-idna,
  python3-ijson (>= 3.1.4),
  python3-jinja2 (>= 3.0),
@@ -64,9 +64,8 @@
 Depends:
  adduser,
  libjs-jquery,
- lsb-base (>= 3.0-6),
- libpython3-stdlib (<< 3.6.4~rc1-2~) | python3-distutils,
- python3 (>= 3.9),
+ lsb-base,
+ python3-distutils,
  python3-bleach,
  python3-jinja2 (>= 3.0~),
  python3-lxml,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
include /usr/share/rustc/architecture.mk

export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE

export PYBUILD_NAME=matrix-synapse

export PATH := /usr/share/cargo/bin:$(PATH)

export CARGO=/usr/share/cargo/bin/cargo
export CARGO_HOME=$(CURDIR)/debian/cargo_home

export DEB_CARGO_CRATE=$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM)

%:
	dh $@ --buildsystem=pybuild

execute_before_dh_auto_configure:
	sed -i '/common/s/~=/>=/' pyproject.toml
	$(CARGO) prepare-debian debian/cargo_registry --link-from-system

execute_after_dh_auto_clean:
	rm -rf debian/cargo_registry

override_dh_auto_install:
	dh_auto_install
	for f in $$(find debian/$(PYBUILD_NAME) -name 'jquery*min.js'); \
	do \
	    rm $$f; \
	    ln -s /usr/share/javascript/jquery/jquery.min.js $$f; \
	done
	sed -i \
		-e 's,#!/usr/bin/env perl,#!/usr/bin/perl,' \
		debian/*/usr/bin/*
	mv debian/*/usr/bin/* debian/*/usr/libexec/*/

execute_after_dh_installdocs:
	mv debian/$(PYBUILD_NAME)/usr/share/doc/matrix-synapse/installation.md \
	   debian/$(PYBUILD_NAME)/usr/share/doc/matrix-synapse/INSTALL.md
	mv debian/$(PYBUILD_NAME)/usr/share/doc/matrix-synapse/upgrade.md \
	   debian/$(PYBUILD_NAME)/usr/share/doc/matrix-synapse/UPGRADE.md
	ln -sr debian/$(PYBUILD_NAME)/usr/share/doc/matrix-synapse/UPGRADE.md \
	       debian/$(PYBUILD_NAME)/usr/share/doc/matrix-synapse/UPGRADE.rst
	sed -i \
		-e 's,/opt/venvs/matrix-synapse/bin/python,/usr/bin/python3,' \
		-e 's,Restart=always,Restart=on-failure,' \
		debian/*/usr/share/doc/matrix-synapse/misc/systemd-with-workers/system/*.service

override_dh_compress:
	dh_compress -XREADME

override_dh_auto_test:

vendor:
	-[ -d vendor ] && rm -rf vendor
	cargo vendor --locked
	tar Jcf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig-vendor.tar.xz vendor/

.PHONY: override_dh_auto_install override_dh_auto_test vendor

## matrix-synapse 1.94.0

=== debian/changelog ===
matrix-synapse (1.94.0-1) unstable; urgency=high

  * New upstream release (CVE-2023-45129).

 -- Antonio Russo <aerusso@aerusso.net>  Wed, 11 Oct 2023 14:04:46 +0100

matrix-synapse (1.93.0-1) unstable; urgency=medium

  [ Antonio Russo ]
  * New upstream release (Closes: #1053283, CVE-2023-42453, CVE-2023-41335).
  * Refresh patches.
  * Revert pillow version bump.

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 01 Oct 2023 09:41:18 +0200

matrix-synapse (1.92.0-3) unstable; urgency=medium

  * Add the missing dh-cargo build-dependency.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 26 Sep 2023 08:31:13 +0200

matrix-synapse (1.92.0-2) unstable; urgency=medium

  [ Antonio Russo ]
  * Run tests.

  [ Andrej Shadura ]
  * Don’t require test dependencies in nocheck mode.
  * Simplify dependencies on Rust crates by using semver virtual packages.
  * Generate Build-Using and Static-Built-Using.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 25 Sep 2023 22:58:29 +0200

matrix-synapse (1.92.0-1) unstable; urgency=medium

  * New upstream release.
  * Remove vendored sources and related infrastructure.
  * Use Rust crates from Debian.
  * Bump pyo3 dependency.

 -- Antonio Russo <aerusso@aerusso.net>  Mon, 18 Sep 2023 22:49:51 +0200

matrix-synapse (1.91.2-2) unstable; urgency=medium

  * Revert upstream Cargo.lock changes.

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 10 Sep 2023 13:34:33 +0200

matrix-synapse (1.91.2-1) unstable; urgency=medium

  * New upstream release.

  [ Antonio Russo ]
  * Replace frozendict dependency by immutabledict.

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 10 Sep 2023 12:56:47 +0200

## matrix-synapse 1.95.0

=== debian/changelog ===
matrix-synapse (1.95.0-1) unstable; urgency=medium

  * New upstream release.
  * Relax upstream pyo3 0.19 dependency.
  * Drop patch for pyo3 applied upstream.

 -- Antonio Russo <aerusso@aerusso.net>  Tue, 24 Oct 2023 17:59:40 -0600

## matrix-synapse 1.95.1

=== debian/changelog ===
matrix-synapse (1.95.1-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 09 Nov 2023 08:57:43 +0100

matrix-synapse (1.95.1-1) unstable; urgency=high

  * New upstream release (CVE-2023-43796, Closes: #1055255).

 -- Andrej Shadura <andrew.shadura@collabora.co.uk>  Sat, 04 Nov 2023 21:12:29 +0100

matrix-synapse (1.95.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Cherry-pick fix for GHSA-mp92-3jfm-3575 (CVE-2023-43796),
    closes: #1055255.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 08 Nov 2023 18:04:53 +0100

matrix-synapse (1.94.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 13 Oct 2023 12:25:58 +0100

matrix-synapse (1.92.0-3~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Drop Static-Built-Using to avoid build dependency on
    dh-sequence-builtusing.
  * Downgrade pyo3 dependency back to what’s in backports.
  * Add build dependency on aho-corasick since our Rust crate combination
    in backports needs it.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 03 Oct 2023 09:37:58 +0200

matrix-synapse (1.91.2-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 27 Sep 2023 14:53:14 +0200

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,21 @@
 Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
+ dh-cargo,
  dh-sequence-single-binary,
  dh-sequence-python3,
  libjs-jquery,
+ librust-anyhow-1-dev (>= 1.0.63),
+ librust-blake2-0.10-dev (>= 0.10.4),
+ librust-hex-0.4-dev (>= 0.4.3),
+ librust-lazy-static-1-dev (>= 1.4.0),
+ librust-log-0.4-dev (>= 0.4.17),
+ librust-pyo3-0.17-dev (>= 0.17.0),
+ librust-pyo3-log-0.8-dev (>= 0.8.1),
+ librust-pythonize-0.19-dev (>= 0.19.0),
+ librust-regex-1+aho-corasick-dev (>= 1.6.0),
+ librust-serde-1-dev (>= 1.0.144),
+ librust-serde-json-1-dev (>= 1.0.85),
  po-debconf,
  pybuild-plugin-pyproject,
  python3-poetry-core,
@@ -18,10 +30,10 @@
  python3-cryptography,
  python3-canonicaljson (>= 2.0.0~),
  python3-daemonize,
- python3-frozendict (>= 1.2-3~),
  python3-icu (>= 2.10.2~),
  python3-idna,
  python3-ijson (>= 3.1.4),
+ python3-immutabledict (>= 2.0.0),
  python3-jinja2 (>= 3.0),
  python3-jsonschema (>= 3.0.0),
  python3-lxml (>= 4.2.0),
@@ -32,6 +44,7 @@
  python3-netaddr (>= 0.7.18),
  python3-openssl (>= 0.14),
  python3-packaging (>= 16.1),
+ python3-parameterized <!nocheck>,
  python3-phonenumbers,
  python3-pil (>= 5.4.0),
  python3-prometheus-client,
@@ -40,6 +53,8 @@
  python3-pydantic (>= 1.7.4),
  python3-pymacaroons (>= 0.13.0),
  python3-pysaml2 (>= 4.0.0),
+ python3-pytest <!nocheck>,
+ python3-pytest-twisted <!nocheck>,
  python3-service-identity (>= 18.1.0),
  python3-setuptools (>= 0.6b3),
  python3-setuptools-rust (>= 1.2.0~),
@@ -81,6 +96,8 @@
 Suggests:
  python3-jwt (>= 1.6.4),
  python3-authlib (>= 0.14.0),
+Built-Using: ${cargo:Built-Using}
+XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
 Recommends:
  python3-pympler,
  matrix-synapse-ldap3,

=== debian/rules ===
--- 
+++ 
@@ -24,6 +24,7 @@
 
 execute_after_dh_auto_clean:
 	rm -rf debian/cargo_registry
+	mv Cargo.lock debian/Cargo.lock.orig || true
 
 override_dh_auto_install:
 	dh_auto_install
@@ -36,6 +37,7 @@
 		-e 's,#!/usr/bin/env perl,#!/usr/bin/perl,' \
 		debian/*/usr/bin/*
 	mv debian/*/usr/bin/* debian/*/usr/libexec/*/
+	/usr/share/cargo/bin/dh-cargo-built-using matrix-synapse
 
 execute_after_dh_installdocs:
 	mv debian/$(PYBUILD_NAME)/usr/share/doc/matrix-synapse/installation.md \
@@ -52,11 +54,8 @@
 override_dh_compress:
 	dh_compress -XREADME
 
-override_dh_auto_test:
+override_dh_auto_clean:
+	mv debian/Cargo.lock.orig Cargo.lock || true
+	dh_auto_clean
 
-vendor:
-	-[ -d vendor ] && rm -rf vendor
-	cargo vendor --locked
-	tar Jcf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig-vendor.tar.xz vendor/
-
-.PHONY: override_dh_auto_install override_dh_auto_test vendor
+.PHONY: override_dh_auto_install

## matrix-synapse 1.97.0

=== debian/changelog ===
matrix-synapse (1.97.0-1) unstable; urgency=medium

  * New upstream release.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 29 Nov 2023 09:30:19 +0100

=== debian/control ===
--- 
+++ 
@@ -8,16 +8,17 @@
  dh-cargo,
  dh-sequence-single-binary,
  dh-sequence-python3,
+ dh-sequence-builtusing,
  libjs-jquery,
  librust-anyhow-1-dev (>= 1.0.63),
  librust-blake2-0.10-dev (>= 0.10.4),
  librust-hex-0.4-dev (>= 0.4.3),
  librust-lazy-static-1-dev (>= 1.4.0),
  librust-log-0.4-dev (>= 0.4.17),
- librust-pyo3-0.17-dev (>= 0.17.0),
+ librust-pyo3-0.19-dev (>= 0.19.0),
  librust-pyo3-log-0.8-dev (>= 0.8.1),
  librust-pythonize-0.19-dev (>= 0.19.0),
- librust-regex-1+aho-corasick-dev (>= 1.6.0),
+ librust-regex-1-dev (>= 1.6.0),
  librust-serde-1-dev (>= 1.0.144),
  librust-serde-json-1-dev (>= 1.0.85),
  po-debconf,
@@ -98,6 +99,18 @@
  python3-authlib (>= 0.14.0),
 Built-Using: ${cargo:Built-Using}
 XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
+Static-Built-Using:
+ ${dh-builtusing:librust-anyhow-dev},
+ ${dh-builtusing:librust-blake2-dev},
+ ${dh-builtusing:librust-hex-dev},
+ ${dh-builtusing:librust-lazy-static-dev},
+ ${dh-builtusing:librust-log-dev},
+ ${dh-builtusing:librust-pyo3-dev},
+ ${dh-builtusing:librust-pyo3-log-dev},
+ ${dh-builtusing:librust-pythonize-dev},
+ ${dh-builtusing:librust-regex-dev},
+ ${dh-builtusing:librust-serde-dev},
+ ${dh-builtusing:librust-serde-json-dev},
 Recommends:
  python3-pympler,
  matrix-synapse-ldap3,

## matrix-synapse 1.100.0

=== debian/changelog ===
matrix-synapse (1.100.0-1ubuntu1) noble; urgency=medium

  * Drop dependency on python3-distutils.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 09 Mar 2024 12:32:49 +0100

matrix-synapse (1.100.0-1) unstable; urgency=medium

  * New upstream release.

 -- Antonio Russo <aerusso@aerusso.net>  Wed, 31 Jan 2024 17:50:11 +0100

matrix-synapse (1.99.0-3) unstable; urgency=medium

  * Only run autopkgtests on the current Python.
    Tests expect the temporary directory to not exist, and it only
    makes sense to run tests with the default Python since that’s what
    Synapse runs on.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 27 Jan 2024 15:06:14 +0100

matrix-synapse (1.99.0-2) unstable; urgency=medium

  * Run autopkgtest-pkg-pybuild testsuite.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 27 Jan 2024 09:43:25 +0100

matrix-synapse (1.99.0-1) unstable; urgency=medium

  [ Antonio Russo ]
  * New upstream: Element.
  * New upstream release.
  * Update license and copyright information.
  * Refresh patches.
  * Update build dependencies.

  [ Andrej Shadura ]
  * Drop dependency on the obsolete package lsb-base.
  * Update standards version to 4.6.2, no changes needed.

 -- Antonio Russo <aerusso@aerusso.net>  Fri, 26 Jan 2024 12:20:52 +0100

=== debian/control ===
--- 
+++ 
@@ -15,9 +15,9 @@
  librust-hex-0.4-dev (>= 0.4.3),
  librust-lazy-static-1-dev (>= 1.4.0),
  librust-log-0.4-dev (>= 0.4.17),
- librust-pyo3-0.19-dev (>= 0.19.0),
- librust-pyo3-log-0.8-dev (>= 0.8.1),
- librust-pythonize-0.19-dev (>= 0.19.0),
+ librust-pyo3-0.20-dev (>= 0.20.0),
+ librust-pyo3-log-0.9-dev (>= 0.9.0),
+ librust-pythonize-0.20-dev (>= 0.20.0),
  librust-regex-1-dev (>= 1.6.0),
  librust-serde-1-dev (>= 1.0.144),
  librust-serde-json-1-dev (>= 1.0.85),
@@ -67,8 +67,9 @@
  python3-typing-extensions (>= 3.10~),
  python3-unpaddedbase64 (>= 2.1.0~),
  python3-yaml
-Standards-Version: 4.6.0
-Homepage: https://matrix.org/docs/projects/server/synapse.html
+Standards-Version: 4.6.2
+Testsuite: autopkgtest-pkg-pybuild
+Homepage: https://github.com/element-hq/synapse
 Vcs-Browser: https://salsa.debian.org/matrix-team/matrix-synapse
 Vcs-Git: https://salsa.debian.org/matrix-team/matrix-synapse.git
 Rules-Requires-Root: no
@@ -80,8 +81,6 @@
 Depends:
  adduser,
  libjs-jquery,
- lsb-base,
- python3-distutils,
  python3-bleach,
  python3-jinja2 (>= 3.0~),
  python3-lxml,

=== debian/rules ===
--- 
+++ 
@@ -58,4 +58,12 @@
 	mv debian/Cargo.lock.orig Cargo.lock || true
 	dh_auto_clean
 
-.PHONY: override_dh_auto_install
+PYTHONS=$(wildcard /usr/bin/python3.? /usr/bin/python3.??)
+CURRENT_PYTHON=$(shell readlink -f /usr/bin/python3)
+OTHER_PYTHONS=$(filter-out $(CURRENT_PYTHON),$(PYTHONS))
+OTHER_PYTHON_VERSIONS=$(subst /usr/bin/python,,$(OTHER_PYTHONS))
+
+pybuild-autopkgtest: export PYBUILD_VERBOSE=1
+pybuild-autopkgtest: export PYBUILD_DISABLE=$(OTHER_PYTHON_VERSIONS)
+
+.PHONY: pybuild-autopkgtest

## matrix-synapse 1.121.0

=== debian/changelog ===
matrix-synapse (1.121.0-4) unstable; urgency=medium

  * Fix typo in Belarusian debconf template translation.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 21 Dec 2024 13:56:27 +0100

matrix-synapse (1.121.0-3) unstable; urgency=medium

  [ Remus-Gabriel Chelu ]
  * Add Romanian debconf template translation (Closes: #1090925)

  [ Andrej Shadura ]
  * Add Belarusian debconf template translation.
  * Add Slovak debconf template translation.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 21 Dec 2024 13:54:24 +0100

matrix-synapse (1.121.0-2) unstable; urgency=medium

  [ Colin Watson ]
  * Handle python3-multipart → python3-python-multipart renaming.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 13 Dec 2024 08:30:54 +0100

matrix-synapse (1.121.0-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Temporarily revert pyo3 version bump
  * Apply patches from the Twisted 24.11 compatibility upstream MR.

 -- Antonio Russo <aerusso@aerusso.net>  Thu, 12 Dec 2024 10:15:24 +0100

matrix-synapse (1.116.0-4) unstable; urgency=medium

  * Require python3-typing-extensions >= 4.1.
  * Regenerate the patch series.
  * Apply upstream patch for Twisted 24.10.0 compatibility:
    - Remove usage of internal header encoding API
    Closes: #1087239
  * Temporarily skip test failures.

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 10 Nov 2024 20:57:58 +0100

matrix-synapse (1.116.0-3) unstable; urgency=medium

  [ Peter Michael Green ]
  * Fix build process so vendored sources are actually used
    (Closes: #1084037).
  * Relax cargo dependency and Debian build-dependency on base64 crate.
  * Fix clean target.

  [ Antonio Russo ]
  * python3-cryptography is now available.
  * Clean up old, removed dependencies.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 08 Oct 2024 13:11:26 +0200

matrix-synapse (1.116.0-2) unstable; urgency=medium

  * Removing myself as uploader,
    with sincere apology for total lack of coordination
  * Revert to again build-depend on dh-cargo (not dh-rust)

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 03 Oct 2024 23:13:22 +0200

matrix-synapse (1.116.0-1) unstable; urgency=medium

  [ Upstream ]
  * New release(s)
    + Bump twisted to 24.7.0;
      closes: bug#1079083, thanks to Colin Watson

  [ Jonas Smedegaard ]
  * Update and unfuzz patches
  * Add patch to accept older releases/branches
    of crates bytes, headers and http
  * Update copyright info:
    + Update source URI
    + Add Upstream-Contact URI
    + Update coverage
    + Sort license sections alphabetically;
    + Use reference field for license section Apache-2.0
  * Update build-dependencies and dh-builtusing hints
  * Simplify rules;
    build-depend on dh-rust (not dh-cargo);
    add X-Cargo-Crates hint;
    drop patch debian-rust
  * Add unofficial rule get-vendorlibs,
    to embed crates listed in TODO
  * Embed crates pyo3, while Debian-packaged crates are too new;
    closes: bug#1080392, thanks to Santiago Vila
  * Embed crate ulid, until separately packaged in Debian
    (see bug#1083195)
  * Add source helper script copyright-check
  * Add myself as uploader
  * Enable hardening build options
  * Use upstream optimization level

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 03 Oct 2024 19:02:50 +0200

matrix-synapse (1.103.0-5) unstable; urgency=medium

  [ Emmanuel Arias ]
  * Remove python3-distutils from Dependency, it was already removed by upstream
    (Closes: #1065900)

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 13 Jul 2024 22:51:08 +0200

matrix-synapse (1.103.0-4) unstable; urgency=medium

  * Ignore test failures on 32-bit architectures.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 29 May 2024 10:29:25 +0200

matrix-synapse (1.103.0-3) unstable; urgency=high

  * Add a patch CVE-2024-31208 depends on and a regression fix for it.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 29 May 2024 08:49:31 +0200

matrix-synapse (1.103.0-2) unstable; urgency=medium

  * Fix CVE-2024-31208 / GHSA-3h7q-rfh9-xm4v:
    - Weakness in auth chain indexing allows DoS from remote room members
      through disk fill and high CPU usage.
    Closes: 1069763

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 25 May 2024 16:22:51 +0200

matrix-synapse (1.103.0-1) unstable; urgency=medium

  [ Antonio Russo ]
  * New upstream release.

  [ Andrej Shadura ]
  * Remove obsolete build-dependency python3-mock (Closes: #1067236).

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 20 Mar 2024 17:48:38 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: matrix-synapse
 Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
-Uploaders: Andrej Shadura <andrewsh@debian.org>
+Uploaders:
+ Andrej Shadura <andrewsh@debian.org>,
 Section: net
 Priority: optional
 Build-Depends:
@@ -10,17 +11,53 @@
  dh-sequence-python3,
  dh-sequence-builtusing,
  libjs-jquery,
- librust-anyhow-1-dev (>= 1.0.63),
- librust-blake2-0.10-dev (>= 0.10.4),
- librust-hex-0.4-dev (>= 0.4.3),
- librust-lazy-static-1-dev (>= 1.4.0),
- librust-log-0.4-dev (>= 0.4.17),
- librust-pyo3-0.20-dev (>= 0.20.0),
- librust-pyo3-log-0.9-dev (>= 0.9.0),
- librust-pythonize-0.20-dev (>= 0.20.0),
- librust-regex-1-dev (>= 1.6.0),
- librust-serde-1-dev (>= 1.0.144),
- librust-serde-json-1-dev (>= 1.0.85),
+ librust-anyhow-1+default-dev (>= 1.0.63),
+ librust-base64-0+default-dev (>= 0.21.7),
+ librust-bytes-1+default-dev (>= 1.5),
+ librust-blake2-0.10+default-dev (>= 0.10.4) <!nocheck>,
+ librust-headers-dev (<< 0.5),
+ librust-http-dev (<< 2),
+ librust-hex-0.4+default-dev (>= 0.4.3) <!nocheck>,
+ librust-lazy-static-1+default-dev (>= 1.4.0),
+ librust-log-0.4+default-dev (>= 0.4.17),
+ librust-mime-0.3+default-dev (>= 0.3.17),
+#FIXME: enable when upstream project supports pyo3 v0.22 (not only v0.21)
+# librust-pyo3-0.22+abi3-dev,
+# librust-pyo3-0.22+abi3-py38-dev,
+# librust-pyo3-0.22+anyhow-dev,
+# librust-pyo3-0.22+default-dev,
+# librust-pyo3-0.22+macros-dev,
+# librust-pyo3-log-0.11+default-dev,
+# librust-pythonize-0.21+default-dev,
+#FIXME: drop below unversioned build-dependencies when above is solved
+ librust-anyhow-dev,
+ librust-arc-swap-dev,
+ librust-chrono-tz-dev,
+ librust-eyre+default-dev,
+ librust-indoc-dev,
+ librust-inventory-dev,
+ librust-memoffset-dev,
+ librust-num-complex-dev,
+ librust-pyo3-ffi-dev,
+ librust-pyo3-macros-dev,
+ librust-rust-decimal-dev,
+ librust-unindent-dev,
+#FIXME: above below unversioned build-dependencies when above is solved
+ librust-regex-1+default-dev (>= 1.6.0),
+ librust-serde-1+default-dev (>= 1.0.144),
+ librust-serde-1+derive-dev (>= 1.0.144),
+ librust-serde-json-1+default-dev (>= 1.0.85),
+ librust-sha2-0.10+default-dev (>= 0.10.8),
+#FIXME: enable when ulid is in Debian
+# librust-ulid-1+default-dev (>= 1.1.2),
+#FIXME: drop below unversioned build-dependency when ulid is in Debian
+ librust-bytes-dev,
+ librust-postgres-types-dev,
+ librust-rand-dev,
+ librust-structopt-dev,
+ librust-time-dev,
+ librust-uuid-dev,
+#FIXME: drop above unversioned build-dependency when ulid is in Debian
  po-debconf,
  pybuild-plugin-pyproject,
  python3-poetry-core,
@@ -30,7 +67,6 @@
  python3-bleach (>= 1.4.2),
  python3-cryptography,
  python3-canonicaljson (>= 2.0.0~),
- python3-daemonize,
  python3-icu (>= 2.10.2~),
  python3-idna,
  python3-ijson (>= 3.1.4),
@@ -39,8 +75,9 @@
  python3-jsonschema (>= 3.0.0),
  python3-lxml (>= 4.2.0),
  python3-matrix-common (>= 1.3.0~),
- python3-mock,
  python3-msgpack (>= 0.5.0),
+ python3-multipart (>= 0.0.9) | python3-python-multipart,
+ python3-multipart (<< 0.1) | python3-python-multipart,
  python3-nacl (>= 1.2.1),
  python3-netaddr (>= 0.7.18),
  python3-openssl (>= 0.14),
@@ -64,7 +101,7 @@
  python3-systemd,
  python3-treq (>= 18),
  python3-twisted (>= 18.9.0-8~),
- python3-typing-extensions (>= 3.10~),
+ python3-typing-extensions (>= 4.1~),
  python3-unpaddedbase64 (>= 2.1.0~),
  python3-yaml
 Standards-Version: 4.6.2
@@ -100,16 +137,25 @@
 XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
 Static-Built-Using:
  ${dh-builtusing:librust-anyhow-dev},
+ ${dh-builtusing:librust-base64-dev},
  ${dh-builtusing:librust-blake2-dev},
+ ${dh-builtusing:librust-bytes-dev},
+ ${dh-builtusing:librust-headers-dev},
  ${dh-builtusing:librust-hex-dev},
+ ${dh-builtusing:librust-http-dev},
  ${dh-builtusing:librust-lazy-static-dev},
  ${dh-builtusing:librust-log-dev},
- ${dh-builtusing:librust-pyo3-dev},
- ${dh-builtusing:librust-pyo3-log-dev},
- ${dh-builtusing:librust-pythonize-dev},
+ ${dh-builtusing:librust-mime-dev},
+#FIXME: enable when no longer embedding those crates
+# ${dh-builtusing:librust-pyo3-dev},
+# ${dh-builtusing:librust-pyo3-log-dev},
+# ${dh-builtusing:librust-pythonize-dev},
  ${dh-builtusing:librust-regex-dev},
  ${dh-builtusing:librust-serde-dev},
  ${dh-builtusing:librust-serde-json-dev},
+ ${dh-builtusing:librust-sha2-dev},
+#FIXME: enable when no longer embedding that crate
+# ${dh-builtusing:librust-ulid-dev},
 Recommends:
  python3-pympler,
  matrix-synapse-ldap3,

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,14 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
+
+# trust upstream optimization level by default
+ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
+export DEB_CFLAGS_MAINT_STRIP=-O2
+export DEB_CXXFLAGS_MAINT_STRIP=-O2
+endif
 
 include /usr/share/dpkg/default.mk
 include /usr/share/rustc/architecture.mk
@@ -15,16 +25,34 @@
 
 export DEB_CARGO_CRATE=$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM)
 
+# resolve all direct entries in first "package..." section in TODO
+VENDORLIBS = $(shell perl -nE \
+ '/^(?:\s{2}[*]\s*(?:(package)|(\S+))|\s{4}[*]\s*(\S+))/ or next; \
+ $$i++ if $$1; exit if $$i > 1 or $$2; say $$3 if $$3 and $$i;' \
+ debian/TODO)
+
+comma = ,
+_mangle = perl -gpi \
+ -e 's/$(1)\W+version = "\K\Q$(subst |,$(comma),$(2))"/$(subst |,$(comma),$(3))"/g;' \
+ $(patsubst %,debian/vendorlibs/%/Cargo.toml,$(4))
+
 %:
 	dh $@ --buildsystem=pybuild
 
 execute_before_dh_auto_configure:
 	sed -i '/common/s/~=/>=/' pyproject.toml
+	mkdir -p debian/cargo_registry
+	for file in $(CURDIR)/debian/vendorlibs/* ; do \
+		name=`basename "$$file"` ;\
+		[ -e debian/cargo_registry/"$$name" ] || ln -sT "$$file" debian/cargo_registry/"$$name" ;\
+	done
 	$(CARGO) prepare-debian debian/cargo_registry --link-from-system
 
 execute_after_dh_auto_clean:
 	rm -rf debian/cargo_registry
 	mv Cargo.lock debian/Cargo.lock.orig || true
+	rm -f setup.py
+	rm -rf debian/cargo_home target
 
 override_dh_auto_install:
 	dh_auto_install
@@ -58,6 +86,11 @@
 	mv debian/Cargo.lock.orig Cargo.lock || true
 	dh_auto_clean
 
+ifeq ($(DEB_HOST_ARCH_BITS),32)
+override_dh_auto_test:
+	-dh_auto_test
+endif
+
 PYTHONS=$(wildcard /usr/bin/python3.? /usr/bin/python3.??)
 CURRENT_PYTHON=$(shell readlink -f /usr/bin/python3)
 OTHER_PYTHONS=$(filter-out $(CURRENT_PYTHON),$(PYTHONS))
@@ -67,3 +100,40 @@
 pybuild-autopkgtest: export PYBUILD_DISABLE=$(OTHER_PYTHON_VERSIONS)
 
 .PHONY: pybuild-autopkgtest
+
+# custom target unused during official build
+get-vendorlibs:
+# preserve and use pristine Cargo.lock
+	[ -f Cargo.lock.orig ] || cp Cargo.lock Cargo.lock.orig
+	cp -f Cargo.lock.orig Cargo.lock
+
+# modernize crates
+	cargo update
+
+# preserve needed crates
+	cargo vendor --versioned-dirs debian/vendorlibs~
+	rm -rf debian/vendorlibs
+	mkdir debian/vendorlibs
+	cd debian/vendorlibs~ && mv --target-directory=../vendorlibs $(VENDORLIBS)
+
+# use newer crates
+	$(call _mangle,structopt,0.2,>= 0.2| <= 0.3,ulid-1.1.3)
+
+# use older crates
+	$(call _mangle,memoffset,0.9,>= 0.8.0| <= 0.9,pyo3-0.21.2)
+
+# avoid WASM-only crates
+	perl -gpi \
+	 -e 's/\[target(\W+cfg\(target)?\W+wasm[^\n]*(\n[^\[\n][^\n]*)*//g;' \
+	 debian/vendorlibs/ulid-1.1.3/Cargo.toml
+
+# strip checksums for mangled crates
+	echo '{"package":"Could not get crate checksum","files":{}}' \
+	 | tee $(patsubst %,debian/vendorlibs/%/.cargo-checksum.json,\
+	 pyo3-0.21.2 \
+	 ulid-1.1.3 \
+	 )
+
+# cleanup
+	rm -rf debian/vendorlibs~
+	[ ! -f Cargo.lock.orig ] || mv -f Cargo.lock.orig Cargo.lock

## matrix-synapse 1.128.0

=== debian/changelog ===
matrix-synapse (1.128.0-1) unstable; urgency=medium

  [ Antonio Russo ]
  * New upstream release.
  * Refresh the default homeserver.yaml.
  * Refresh patches.
  * Vendor un-Debianized Rust dependencies.

  [ Andrej Shadura ]
  * Add Antonio Enrico Russo to Uploaders

 -- Antonio Russo <aerusso@aerusso.net>  Sat, 10 May 2025 23:11:27 +0200

matrix-synapse (1.121.0-6) unstable; urgency=high

  * SECURITY ISSUE: CVE-2025-30355 / GHSA-v56r-hwv5-mxg6 — Federation denial.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 26 Mar 2025 23:01:52 +0100

matrix-synapse (1.121.0-5) unstable; urgency=medium

  * Add Italian debconf translation.
  * Add Spanish debconf translation.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 07 Jan 2025 19:20:19 +0100

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
 Uploaders:
  Andrej Shadura <andrewsh@debian.org>,
+ Antonio Enrico Russo <aerusso@aerusso.net>,
 Section: net
 Priority: optional
 Build-Depends:
@@ -21,28 +22,36 @@
  librust-lazy-static-1+default-dev (>= 1.4.0),
  librust-log-0.4+default-dev (>= 0.4.17),
  librust-mime-0.3+default-dev (>= 0.3.17),
-#FIXME: enable when upstream project supports pyo3 v0.22 (not only v0.21)
-# librust-pyo3-0.22+abi3-dev,
-# librust-pyo3-0.22+abi3-py38-dev,
-# librust-pyo3-0.22+anyhow-dev,
-# librust-pyo3-0.22+default-dev,
-# librust-pyo3-0.22+macros-dev,
-# librust-pyo3-log-0.11+default-dev,
-# librust-pythonize-0.21+default-dev,
-#FIXME: drop below unversioned build-dependencies when above is solved
+#FIXME: enable when debian ships pyo3 v0.23 (not only v0.22)
+# librust-pyo3-0.23+abi3-dev,
+# librust-pyo3-0.23+abi3-py38-dev,
+# librust-pyo3-0.23+anyhow-dev,
+# librust-pyo3-0.23+default-dev,
+# librust-pyo3-0.23+macros-dev,
+# librust-pyo3-log-0.12+default-dev,
+# librust-pythonize-0.23+default-dev,
+# librust-pyo3-ffi-dev,
+# librust-pyo3-macros-dev,
+#FIXME: drop below build-dependencies when above is solved
  librust-anyhow-dev,
  librust-arc-swap-dev,
  librust-chrono-tz-dev,
  librust-eyre+default-dev,
+#FIXME: enable when debian ships heck v0.5 (not only v0.4.1)
+#librust-heck-dev (>= 0.5),
+ librust-quote-dev,
  librust-indoc-dev,
  librust-inventory-dev,
+ librust-log-dev,
  librust-memoffset-dev,
  librust-num-complex-dev,
- librust-pyo3-ffi-dev,
- librust-pyo3-macros-dev,
+ librust-once-cell-dev,
+ librust-proc-macro2-dev,
  librust-rust-decimal-dev,
+ librust-syn-dev,
+ librust-target-lexicon-dev (>= 0.12.14),
  librust-unindent-dev,
-#FIXME: above below unversioned build-dependencies when above is solved
+#FIXME: above below build-dependencies when above is solved
  librust-regex-1+default-dev (>= 1.6.0),
  librust-serde-1+default-dev (>= 1.0.144),
  librust-serde-1+derive-dev (>= 1.0.144),
@@ -50,14 +59,6 @@
  librust-sha2-0.10+default-dev (>= 0.10.8),
 #FIXME: enable when ulid is in Debian
 # librust-ulid-1+default-dev (>= 1.1.2),
-#FIXME: drop below unversioned build-dependency when ulid is in Debian
- librust-bytes-dev,
- librust-postgres-types-dev,
- librust-rand-dev,
- librust-structopt-dev,
- librust-time-dev,
- librust-uuid-dev,
-#FIXME: drop above unversioned build-dependency when ulid is in Debian
  po-debconf,
  pybuild-plugin-pyproject,
  python3-poetry-core,

## matrix-synapse 1.136.0

=== debian/changelog ===
matrix-synapse (1.136.0-1) unstable; urgency=medium

  [ Kurt Roeckx ]
  * New upstream release.
    - Refresh the patches
    - Downgrade some version of Rust dependencies
    - Vendor various Rust dependencies

  [ Carles Pina i Estany ]
  * Add po-debconf Catalan translation.

 -- Kurt Roeckx <kurt@roeckx.be>  Tue, 12 Aug 2025 21:54:47 +0200

=== debian/control ===
--- 
+++ 
@@ -36,7 +36,9 @@
  librust-anyhow-dev,
  librust-arc-swap-dev,
  librust-chrono-tz-dev,
+ librust-displaydoc-dev,
  librust-eyre+default-dev,
+ librust-http-body-util-dev,
 #FIXME: enable when debian ships heck v0.5 (not only v0.4.1)
 #librust-heck-dev (>= 0.5),
  librust-quote-dev,
@@ -47,6 +49,7 @@
  librust-num-complex-dev,
  librust-once-cell-dev,
  librust-proc-macro2-dev,
+ librust-reqwest-dev,
  librust-rust-decimal-dev,
  librust-syn-dev,
  librust-target-lexicon-dev (>= 0.12.14),
@@ -57,6 +60,9 @@
  librust-serde-1+derive-dev (>= 1.0.144),
  librust-serde-json-1+default-dev (>= 1.0.85),
  librust-sha2-0.10+default-dev (>= 0.10.8),
+ librust-synstructure-dev,
+ librust-writeable-dev,
+ librust-zerofrom-dev,
 #FIXME: enable when ulid is in Debian
 # librust-ulid-1+default-dev (>= 1.1.2),
  po-debconf,

=== debian/rules ===
--- 
+++ 
@@ -103,35 +103,35 @@
 
 # custom target unused during official build
 get-vendorlibs:
-# preserve and use pristine Cargo.lock
-	[ -f Cargo.lock.orig ] || cp Cargo.lock Cargo.lock.orig
-	cp -f Cargo.lock.orig Cargo.lock
-
-# modernize crates
-	cargo update
-
 # preserve needed crates
-	cargo vendor --versioned-dirs debian/vendorlibs~
+	/usr/bin/cargo vendor --locked --versioned-dirs debian/vendorlibs~
 	rm -rf debian/vendorlibs
 	mkdir debian/vendorlibs
 	cd debian/vendorlibs~ && mv --target-directory=../vendorlibs $(VENDORLIBS)
 
-# use newer crates
-	$(call _mangle,structopt,0.2,>= 0.2| <= 0.3,ulid-1.1.3)
-
 # use older crates
-	$(call _mangle,memoffset,0.9,>= 0.8.0| <= 0.9,pyo3-0.21.2)
+	$(call _mangle,memoffset,0.9,>= 0.8.0| <= 0.9,pyo3-0.23.5)
 
 # avoid WASM-only crates
 	perl -gpi \
 	 -e 's/\[target(\W+cfg\(target)?\W+wasm[^\n]*(\n[^\[\n][^\n]*)*//g;' \
-	 debian/vendorlibs/ulid-1.1.3/Cargo.toml
+	 debian/vendorlibs/ulid-1.2.1/Cargo.toml
+
+	perl -gpi \
+	 -e 's/\[target\..cfg\(all\(.*target_os = "wasi".*[^\n]*(\n[^\[\n][^\n]*)*//g;' \
+	 debian/vendorlibs/getrandom-0.3.1/Cargo.toml
+
+# avoid Windows-only crates
+	perl -gpi \
+	 -e 's/\[target\..cfg\(all\(windows.*[^\n]*(\n[^\[\n][^\n]*)*//g;' \
+	 debian/vendorlibs/getrandom-0.3.1/Cargo.toml
 
 # strip checksums for mangled crates
 	echo '{"package":"Could not get crate checksum","files":{}}' \
 	 | tee $(patsubst %,debian/vendorlibs/%/.cargo-checksum.json,\
-	 pyo3-0.21.2 \
-	 ulid-1.1.3 \
+	 getrandom-0.3.1 \
+	 pyo3-0.23.5 \
+	 ulid-1.2.1 \
 	 )
 
 # cleanup
